
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

var	gSkinFolder = "";
var gCurrentSkin = "";
var	gFeedArray = new Array();
var gContentArray = new Array();
var	gMouseX = 0;
var	gWidth = 0;

var gHeader_left, gHeader_main, gHeader_right;
var gFooter_left, gFooter_main, gFooter_right;
var gAdd_Button, gAdd_Button_LeftOffset, gAdd_Button_BottomOffset, gAdd_Button_Opacity;
var	gGrow_Button, gGrow_Button_RightOffset, gGrow_Button_BottomOffset
var	gInsert_Pointer, gInsert_Pointer_LeftOffset, gInsert_Pointer_TopOffset;

var	gHeader_Main_LeftOffset, gHeader_Main_RightOffset;
var	gFooter_Main_LeftOffset, gFooter_Main_RightOffset;
var	gArrow_TopOffset, gArrow_LeftOffset, gArrow_Opacity;
var	gInfo_TopOffset, gInfo_RightOffset, gInfo_Opacity;
var	gRemove_TopOffset, gRemove_RightOffset, gRemove_Opacity;
var	gRefresh_TopOffset, gRefresh_RightOffset, gRefresh_Opacity;
var	gHide_TopOffset, gHide_RightOffset, gHide_Opacity;
var gFeed_Text_TopOffset, gFeed_Text_LeftOffset, gFeed_Text_RightOffset, gFeed_Text_Font, gFeed_Text_Style, gFeed_Text_Size, gFeed_Text_Color, gFeed_Text_Color_Rollover;
var gNews_Text_TopOffset, gNews_Text_LeftOffset, gNews_Text_RightOffset, gNews_Text_Font, gNews_Text_Style, gNews_Text_Size, gNews_Text_Color, gNews_Text_Color_Rollover;

var	gDragRow = -1;
var	gInsertPos = -1;

///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseRow(y)
{
	if (gContentArray[y]["row_left"])
	{
		gContentArray[y]["row_left"].src = gSkinFolder + "row_left.png"
		gContentArray[y]["row_left"].reload();
		gContentArray[y]["row_left"].vOffset = gFirstRow_TopOffset + (gRow_Height * y);
	}
	
	if (gContentArray[y]["row_right"])
	{
		gContentArray[y]["row_right"].src = gSkinFolder + "row_right.png"
		gContentArray[y]["row_right"].reload();
		gContentArray[y]["row_right"].vOffset = gFirstRow_TopOffset + (gRow_Height * y);
		gContentArray[y]["row_right"].hOffset = mainWindow.width - gRow_RightOffset;
	}
	
	if (gContentArray[y]["row_main"])
	{
		gContentArray[y]["row_main"].src = gSkinFolder + "row_bg.png"
		gContentArray[y]["row_main"].reload();
		gContentArray[y]["row_main"].vOffset = gFirstRow_TopOffset + (gRow_Height * y);
		gContentArray[y]["row_main"].hOffset = gRow_LeftOffset;
		gContentArray[y]["row_main"].width = mainWindow.width - (gRow_LeftOffset + gRow_RightOffset);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseInfo(y)
{
	if (!gContentArray[y]["info"])
		return;
	gContentArray[y]["info"].src = gSkinFolder + "info_up.png";
	gContentArray[y]["info"].reload();
	gContentArray[y]["info"].vOffset = gContentArray[y]["row_main"].vOffset + gInfo_TopOffset;
	gContentArray[y]["info"].hOffset = mainWindow.width - gInfo_RightOffset;
	gContentArray[y]["info"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['info'], 'gContentArray[" + y + "][^^info^^]', '" + gSkinFolder + "info_up.png', '" + gSkinFolder + "info_down.png');";
	gContentArray[y]["info"].opacity = gInfo_Opacity;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseRemove(y)
{
	if (!gContentArray[y]["remove"])
		return;
	gContentArray[y]["remove"].src = gSkinFolder + "delete_up.png";
	gContentArray[y]["remove"].reload();
	gContentArray[y]["remove"].vOffset = gContentArray[y]["row_main"].vOffset + gRemove_TopOffset;
	gContentArray[y]["remove"].hOffset = mainWindow.width - gRemove_RightOffset;
	gContentArray[y]["remove"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['remove'], 'gContentArray[" + y + "][^^remove^^]', '" + gSkinFolder + "delete_up.png', '" + gSkinFolder + "delete_down.png');";
	gContentArray[y]["remove"].opacity = gRemove_Opacity;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseRefresh(y)
{
	if (!gContentArray[y]["refresh"])
		return;
	gContentArray[y]["refresh"].src = gSkinFolder + "refresh_up.png";
	gContentArray[y]["row_main"].reload();
	gContentArray[y]["refresh"].vOffset = gContentArray[y]["row_main"].vOffset + gRefresh_TopOffset;
	gContentArray[y]["refresh"].hOffset = mainWindow.width - gRefresh_RightOffset;
	gContentArray[y]["refresh"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['refresh'], 'gContentArray[" + y + "][^^refresh^^]', '" + gSkinFolder + "refresh_up.png', '" + gSkinFolder + "refresh_down.png');";
	gContentArray[y]["refresh"].opacity = gRefresh_Opacity;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseHide(y)
{
	if (!gContentArray[y]["hide"])
		return;
	gContentArray[y]["hide"].src = gSkinFolder + "hide_up.png";
	gContentArray[y]["hide"].reload();
	gContentArray[y]["hide"].vOffset = gContentArray[y]["row_main"].vOffset + gHide_TopOffset;
	gContentArray[y]["hide"].hOffset = mainWindow.width - gHide_RightOffset;
	gContentArray[y]["hide"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['hide'], 'gContentArray[" + y + "][^^hide^^]', '" + gSkinFolder + "hide_up.png', '" + gSkinFolder + "hide_down.png');";
	gContentArray[y]["hide"].opacity = gHide_Opacity;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseTextFeed(y)
{
	if (!gContentArray[y]["text"])
		return;
	gContentArray[y]["text"].width = mainWindow.width - (gFeed_Text_LeftOffset + gFeed_Text_RightOffset);
	gContentArray[y]["text"].vOffset = gContentArray[y]["row_main"].vOffset + gFeed_Text_TopOffset;
	gContentArray[y]["text"].hOffset = gFeed_Text_LeftOffset;
	gContentArray[y]["text"].font = gFeed_Text_Font;
	gContentArray[y]["text"].style = gFeed_Text_Style;
	gContentArray[y]["text"].size = gFeed_Text_Size;
	gContentArray[y]["text"].color = gFeed_Text_Color;
	gContentArray[y]["text"].onMouseEnter = "gContentArray[" + y + "]['text'].color = '" + gFeed_Text_Color_Rollover + "';";
	gContentArray[y]["text"].onMouseExit = "gContentArray[" + y + "]['text'].color = '" + gContentArray[y]["text"].color + "';";
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function InitialiseTextNews(y)
{
	if (!gContentArray[y]["text"])
		return;
	gContentArray[y]["text"].width = mainWindow.width - (gNews_Text_LeftOffset + gNews_Text_RightOffset);
	gContentArray[y]["text"].vOffset = gContentArray[y]["row_main"].vOffset + gNews_Text_TopOffset;
	gContentArray[y]["text"].hOffset = gNews_Text_LeftOffset;
	gContentArray[y]["text"].font = gNews_Text_Font;
	gContentArray[y]["text"].style = gNews_Text_Style
	gContentArray[y]["text"].size = gNews_Text_Size;
	gContentArray[y]["text"].color = gNews_Text_Color;
	gContentArray[y]["text"].onMouseEnter = "gContentArray[" + y + "]['text'].color = '" + gNews_Text_Color_Rollover + "';";
	gContentArray[y]["text"].onMouseExit = "gContentArray[" + y + "]['text'].color = '" + gContentArray[y]["text"].color + "';";
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function LoadSkin()
{
	gSkinFolder = "Resources/Skins/" + preferences.skinName.value + "/";
	
	if (gCurrentSkin == preferences.skinName.value)
	{
		UpdateGUI();
		return;
	}

	mainWindow.visible = false;
	mainWindow.shadow = false;
	mainWindow.width = parseInt(preferences.windowWidth.value);
	
	eval(runCommand("cat '" + gSkinFolder + "/skin.js'"));

	if (!gHeader_left)
		gHeader_left = new Image();
	gHeader_left.src = gSkinFolder + "header_left.png";
	gHeader_left.reload();
	
	if (!gHeader_right)
		gHeader_right = new Image();
	gHeader_right.src = gSkinFolder + "header_right.png";
	gHeader_right.reload();
	gHeader_right.hOffset = mainWindow.width - gHeader_Main_RightOffset;
	
	if (!gHeader_main)
		gHeader_main = new Image();
	gHeader_main.src = gSkinFolder + "header_main.png";
	gHeader_main.reload();
	gHeader_main.hOffset = gHeader_Main_LeftOffset;
	gHeader_main.width = mainWindow.width - (gHeader_Main_LeftOffset + gHeader_Main_RightOffset);

	if (!gFooter_left)
		gFooter_left = new Image();
	gFooter_left.src = gSkinFolder + "footer_left.png";
	gFooter_left.reload();
	gFooter_left.vOffset = gFirstRow_TopOffset + (gRow_Height * gContentArray.length)
	
	if (!gFooter_right)
		gFooter_right = new Image();
	gFooter_right.src = gSkinFolder + "footer_right.png";
	gFooter_right.reload();
	gFooter_right.hOffset = mainWindow.width - gFooter_Main_RightOffset;
	gFooter_right.vOffset = gFirstRow_TopOffset + (gRow_Height * gContentArray.length)
	gFooter_right.onMouseDown = "gMouseX = system.event.hOffset; gWidth = mainWindow.width;";
	gFooter_right.onMouseMove = "ResizeWindow()";

	if (!gFooter_main)
		gFooter_main = new Image();
	gFooter_main.src = gSkinFolder + "footer_main.png";
	gFooter_main.reload();
	gFooter_main.hOffset = gFooter_Main_LeftOffset;
	gFooter_main.width = mainWindow.width - (gFooter_Main_LeftOffset + gFooter_Main_RightOffset);
	gFooter_main.vOffset = gFirstRow_TopOffset + (gRow_Height * gContentArray.length);
	
	if (!gAdd_Button)
		gAdd_Button = new Image();
	gAdd_Button.src = gSkinFolder + "add_up.png";
	gAdd_Button.reload();
	gAdd_Button.opacity = gAdd_Button_Opacity;
	gAdd_Button.hOffset = gAdd_Button_LeftOffset;
	gAdd_Button.vOffset = (gFooter_left.vOffset + gFooter_left.srcHeight) - (gAdd_Button.srcHeight + gAdd_Button_BottomOffset);
	gAdd_Button.onMouseDown = "SetImageTracking(gAdd_Button, 'gAdd_Button', '" + gSkinFolder + "add_up.png', '" + gSkinFolder + "add_down.png');";
	gAdd_Button.onMouseUp = "if (RemoveImageTracking(gAdd_Button, '" + gSkinFolder + "add_up.png')) {AddEditFeed();}";
	if (preferences.showHelpTips.value == "1")
		gAdd_Button.tooltip = "Add - brings up a dialog enabling a news feed to be added.";
	else
		gAdd_Button.tooltip = "";
		
	if (!gGrow_Button)
		gGrow_Button = new Image();
	gGrow_Button.src = gSkinFolder + "grow.png";
	gGrow_Button.reload();
	gGrow_Button.hOffset = mainWindow.width - gGrow_Button_RightOffset;
	gGrow_Button.vOffset = (gFooter_left.vOffset + gFooter_left.srcHeight) - (gGrow_Button.srcHeight + gGrow_Button_BottomOffset);
	gGrow_Button.onMouseDown = "gMouseX = system.event.hOffset; gWidth = mainWindow.width;";
	gGrow_Button.onMouseMove = "ResizeWindow()";
	if (preferences.showHelpTips.value == "1")
		gGrow_Button.tooltip = "Grow - drag to grow or shrink the window horizontally (the vertical sizing is automatic).";
	else
		gGrow_Button.tooltip = "";

	for (var y = 0; y < gContentArray.length; y++)
	{
		InitialiseRow(y);
		
		if (gContentArray[y]["remove"])
			InitialiseTextFeed(y);
		else
			InitialiseTextNews(y);
		
		InitialiseInfo(y);
		InitialiseRemove(y);
		InitialiseRefresh(y);
		InitialiseHide(y);
	}

	mainWindow.height = gFooter_left.vOffset + gFooter_left.srcHeight;
	
	UpdateGUI();
	
	gCurrentSkin = preferences.skinName.value;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function CalculateInsertPos(in_Z)
{
	var		y = 0;
	var		insertRow = 0;

	gInsertPos = -1;

	if (gDragRow == 0)
	{
		gInsertPos = 0;
		insertRow = 0;
	}
	else
	{
		for (var z = 0; z < gFeedArray.length; z++)
		{
			var			numContainerItems = 0;
			var			shownContainer = false;
			
			if (gFeedArray[z].loaded)
			{
				for (var x = 0 ; x < gFeedArray[z].items.length; x++)
				{
				
					if (gFeedArray[z].items[x].keep == false)
					{
					}
					else if (gFeedArray[z].items[x] && gFeedArray[z].items[x].hidden)
					{
					}
					else
					{
						if (numContainerItems < gFeedArray[z].maxDisplayItems)
						{
							if (!shownContainer)
							{
								shownContainer = true;
								y++;
								if (gInsertPos == -1 && y == gDragRow)
									gInsertPos = z + 1;
							}
						
							if (gFeedArray[z].open)
							{
								numContainerItems++;
								y++;
								if (gInsertPos == -1 && y == gDragRow)
									gInsertPos = z + 1;
							}
						}
	
					}
				}
			}
			
			if (!shownContainer && preferences.autoHideFeeds.value != "1")
			{
				y++;
				if (gInsertPos == -1 && y == gDragRow)
					gInsertPos = z + 1;
			}
			
			insertRow = y;
			
			if (gInsertPos != -1)
				break;
		}
	}
	if (gInsertPos == in_Z || gInsertPos == in_Z + 1)
		gInsertPos = -1;
	
	if (gInsertPos == -1)
	{
		if (gInsert_Pointer)
			gInsert_Pointer.opacity = 0;
	}
	else
	{
		if (!gInsert_Pointer)
			gInsert_Pointer = new Image();
		gInsert_Pointer.src = gSkinFolder + "insert_pointer.png";
		gInsert_Pointer.reload();
		gInsert_Pointer.hOffset = gInsert_Pointer_LeftOffset;
		gInsert_Pointer.vOffset = gFirstRow_TopOffset + (insertRow * gRow_Height) + gInsert_Pointer_TopOffset;
		gInsert_Pointer.zOrder = 9999;
		gInsert_Pointer.opacity = gInsert_Pointer_Opacity;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function EndFeedDrag(z, y)
{
	if (gInsert_Pointer)
		gInsert_Pointer.opacity = 0;

	InitialiseTextFeed(y);
	gContentArray[y]["text"].opacity = 255;
	gContentArray[y]["text"].zOrder = 9999;
	gContentArray[y]["text"].onMouseMove = "StartFeedDrag(" + z + ", " + y + ")";
	if (gFeedArray[z].link != "")
		gContentArray[y]["text"].onMouseUp = "openURL('" + gFeedArray[z].link + "');";

	if (gInsertPos != -1)
	{
		if (gInsertPos < z || gInsertPos > (z + 1))
		{
			var		moveFeedArray;
			
			moveFeedArray = gFeedArray.splice(z, 1);
			if (z < gInsertPos)
				gInsertPos--;
			gFeedArray.splice(gInsertPos, 0, moveFeedArray[0]);

			SaveFeeds();
		}
	}

	UpdateGUI();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function MoveFeedDrag(z, y)
{
	var		newVOffset = system.event.vOffset;
	var		row;
	
	if (newVOffset < gFirstRow_TopOffset)
		newVOffset = gFirstRow_TopOffset;
	if (newVOffset > gFirstRow_TopOffset + (gContentArray.length * gRow_Height))
		newVOffset = gFirstRow_TopOffset + (gContentArray.length * gRow_Height);
	
	row = Math.floor((newVOffset - gFirstRow_TopOffset + 10) / gRow_Height);
	if (row != gDragRow)
	{
		gDragRow = row;
		CalculateInsertPos(z);
	}
	
	gContentArray[y]["text"].opacity = 150;
	gContentArray[y]["text"].zOrder = 10000;
	gContentArray[y]["text"].onMouseUp = "EndFeedDrag(" + z + ", " + y + ");";
	gContentArray[y]["text"].vOffset = newVOffset;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function StartFeedDrag(z, y)
{
	gDragRow = -1;
	gContentArray[y]["text"].onMouseMove = "MoveFeedDrag(" + z + ", " + y + ");";
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function ResizeWindow()
{
	var		newWidth;

	suppressUpdates();
	
	newWidth = system.event.hOffset - gMouseX + gWidth;
	if (newWidth < 200)
		newWidth = 200;
	if (mainWindow.width == newWidth)
		return;
		
	mainWindow.width = newWidth;

	gHeader_right.hOffset = mainWindow.width - gHeader_Main_RightOffset;
	gHeader_main.width = mainWindow.width - (gHeader_Main_LeftOffset + gHeader_Main_RightOffset);

	gFooter_right.hOffset = mainWindow.width - gFooter_Main_RightOffset;
	gFooter_main.width = mainWindow.width - (gFooter_Main_LeftOffset + gFooter_Main_RightOffset);
	
	for (var y = 0; y < gContentArray.length; y++)
	{
		gContentArray[y]["row_right"].hOffset = mainWindow.width - gRow_RightOffset;
		gContentArray[y]["row_main"].width = mainWindow.width - (gRow_LeftOffset + gRow_RightOffset);
		if (gContentArray[y]["remove"])
			gContentArray[y]["text"].width = mainWindow.width - (gFeed_Text_LeftOffset + gFeed_Text_RightOffset);
		else
			gContentArray[y]["text"].width = mainWindow.width - (gNews_Text_LeftOffset + gNews_Text_RightOffset);
		if (gContentArray[y]["info"])
			gContentArray[y]["info"].hOffset = mainWindow.width - gInfo_RightOffset;
		if (gContentArray[y]["remove"])
			gContentArray[y]["remove"].hOffset = mainWindow.width - gRemove_RightOffset;
		if (gContentArray[y]["refresh"])
			gContentArray[y]["refresh"].hOffset = mainWindow.width - gRefresh_RightOffset;
		if (gContentArray[y]["hide"])
			gContentArray[y]["hide"].hOffset = mainWindow.width - gHide_RightOffset;
	}
	
	gGrow_Button.hOffset = gGrow_Button.hOffset = mainWindow.width - gGrow_Button_RightOffset;
	
	preferences.windowWidth.value = mainWindow.width;
	savePreferences();
	
	if (mainWindow.shadow)
		mainWindow.recalcShadow();
	
	resumeUpdates();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function SetImageTracking(theImage, theImageName, theImage_UpSrc, theImage_DownSrc)
{
	var		tempString = "";
	
	// this could probably have been avoided, but theImageName might contain quotes itself, eg. contentsArray[1]["hide"]
	// so, the way round this is to encode those quotes as ^^, and then we'll convert them back here
	
	theImageName = theImageName.replace(/\^\^/g, "'");

	theImage.onMouseEnter = theImageName + ".src = '" + theImage_DownSrc + "';";
	theImage.onMouseExit = theImageName + ".src = '" + theImage_UpSrc + "';";
	theImage.src = theImage_DownSrc;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function RemoveImageTracking(theImage, theImage_UpSrc)
{
	var		buttonDown = true;
	
	if (theImage.src == theImage_UpSrc)
		buttonDown = false;
	theImage.onMouseEnter = "";
	theImage.onMouseExit = "";
	theImage.src = theImage_UpSrc;
	
	return buttonDown;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function EnsureRowBackground(y)
{
	var		growWindow = false;
	
	if (!gContentArray[y])
	{
		gContentArray[y] = new Array();
		growWindow = true;
	}
	
	if (!gContentArray[y]["row_left"])
	{
		gContentArray[y]["row_left"] = new Image();
		gContentArray[y]["row_main"] = new Image();
		gContentArray[y]["row_right"] = new Image();
		InitialiseRow(y);
	}
	
	return growWindow;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function SetContainerText(z, y, numContainerItems, containerToolTip)
{
		// always want to show refresh
	if (!gContentArray[y]["refresh"])
	{
		gContentArray[y]["refresh"] = new Image();
		InitialiseRefresh(y);
	}
	gContentArray[y]["refresh"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['refresh'], '" + gSkinFolder + "refresh_up.png')) {gFeedArray[" + z + "].Refresh();}";
	if (preferences.showHelpTips.value == "1")
		gContentArray[y]["refresh"].tooltip = "Refresh - reloads this news feed, and clears the hidden settings, resulting in all it's current news items being shown\r\rHold down option to only reload this news feed and NOT clear the hidden settings.";
	else
		gContentArray[y]["refresh"].tooltip = "";

		// if there aren't any items, then it's either still loading, or
		// there's been an error
	if (gFeedArray[z].items.length == 0)
	{
		delete gContentArray[y]["hide"];
		delete gContentArray[y]["arrow"];
		if (!gFeedArray[z].loaded)
		{
			gContentArray[y]["text"].data = "(Loading … " + gFeedArray[z].GetDisplayTitle() + ")";
			gContentArray[y]["text"].color = gFeed_Text_Color_Empty;
			gContentArray[y]["text"].onMouseExit = "gContentArray[" + y + "]['text'].color = '" + gFeed_Text_Color_Empty + "';";
		}
		else
		{
			gContentArray[y]["text"].data = "Error: " + gFeedArray[z].GetDisplayTitle();
			gContentArray[y]["text"].color = "#990000";
			gContentArray[y]["text"].onMouseExit = "gContentArray[" + y + "]['text'].color = '#990000';";
		}
		return;
	}
	
	if (preferences.autoCloseFeeds.value == "1" && numContainerItems == 0)
	{
		// auto close is turned on, and the container hasn't displayed any items,
		// so do NOT show arrow, as the container couldn't be opened anyway
		delete gContentArray[y]["arrow"];
	}
	else
	{
			// show arrow - we still show arrows even if the container hasn't displayed any
			// items (as long as auto close is turned off) - which allows the user to open or
			// close the news feed for when any new items come in
		if (!gContentArray[y]["arrow"])
			gContentArray[y]["arrow"] = new Image();
		if (gFeedArray[z].open)
		{
			gContentArray[y]["arrow"].src = gSkinFolder + "arrow_open_up.png";
			gContentArray[y]["arrow"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['arrow'], 'gContentArray[" + y + "][^^arrow^^]', '"+ gSkinFolder + "arrow_open_up.png', '" + gSkinFolder + "arrow_open_down.png');";
			gContentArray[y]["arrow"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['arrow'], '" + gSkinFolder + "arrow_open_up.png')) {gFeedArray[" + z + "].ToggleOpen(true);}";
			if (preferences.showHelpTips.value == "1")
				gContentArray[y]["arrow"].tooltip = "Close - closes this news feed.";
			else
				gContentArray[y]["arrow"].tooltip = "";
		}
		else
		{
			gContentArray[y]["arrow"].src = gSkinFolder + "arrow_closed_up.png";
			gContentArray[y]["arrow"].onMouseDown = "SetImageTracking(gContentArray[" + y + "]['arrow'], 'gContentArray[" + y + "][^^arrow^^]', '"+ gSkinFolder + "arrow_closed_up.png', '" + gSkinFolder + "arrow_closed_down.png');";
			gContentArray[y]["arrow"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['arrow'], '" + gSkinFolder + "arrow_closed_up.png')) {gFeedArray[" + z + "].ToggleOpen(true);}";
			if (preferences.showHelpTips.value == "1")
				gContentArray[y]["arrow"].tooltip = "Open - opens this news feed and shows the news items within.";
			else
				gContentArray[y]["arrow"].tooltip = "";
		}
		gContentArray[y]["arrow"].reload();
		gContentArray[y]["arrow"].vOffset = gContentArray[y]["row_main"].vOffset + gArrow_TopOffset;
		gContentArray[y]["arrow"].hOffset = gArrow_LeftOffset;
		gContentArray[y]["arrow"].opacity = gArrow_Opacity;
	}

		// show hide button - only if we've displayed any items
	if (numContainerItems == 0)
		delete gContentArray[y]["hide"];
	else
	{
		if (!gContentArray[y]["hide"])
		{
			gContentArray[y]["hide"] = new Image();
			InitialiseHide(y);
		}
		gContentArray[y]["hide"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['hide'], '" + gSkinFolder + "hide_up.png')) {gFeedArray[" + z + "].Hide();}";
		if (preferences.showHelpTips.value == "1")
			gContentArray[y]["hide"].tooltip = "Hide - hides all news items in this news feed\r\rHold down option to hide only the currently displayed items";
		else
			gContentArray[y]["hide"].tooltip = "";
	}
	
	gContentArray[y]["text"].data = gFeedArray[z].GetDisplayTitle();
	gContentArray[y]["text"].tooltip = containerToolTip;
	if (numContainerItems > 0)
	{
		gContentArray[y]["text"].data += " (" + numContainerItems + ")";
		gContentArray[y]["text"].color = gFeed_Text_Color;
	}
	else
	{
		gContentArray[y]["text"].color = gFeed_Text_Color_Empty;
	}
	gContentArray[y]["text"].onMouseExit = "gContentArray[" + y + "]['text'].color = '" + gContentArray[y]["text"].color + "'";
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function SetContainer(z, y)
{
	var		growWindow = false;
	var		rowOffset;

	if (!gContentArray)
		return;

	growWindow = EnsureRowBackground(y);

	if (gContentArray[y]["text"])
	{
			// if it's a news text currently, reinitialise as a feed text
		if (!gContentArray[y]["remove"])
		InitialiseTextFeed(y);
	}
	else
	{
		gContentArray[y]["text"] = new Text();
		InitialiseTextFeed(y);
	}
	gContentArray[y]["text"].data = gFeedArray[z].GetDisplayTitle();
	gContentArray[y]["text"].onMouseMove = "StartFeedDrag(" + z + ", " + y + ")";
	if (gFeedArray[z].link != "")
		gContentArray[y]["text"].onMouseUp = "openURL('" + gFeedArray[z].link + "');";
	gContentArray[y]["text"].tooltip = "";
	
	if (!gContentArray[y]["remove"])
	{
		gContentArray[y]["remove"] = new Image();
		InitialiseRemove(y);
	}
	gContentArray[y]["remove"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['remove'], '" + gSkinFolder + "delete_up.png')) {RemoveFeed(" + z + ");}";
	if (preferences.showHelpTips.value == "1")
		gContentArray[y]["remove"].tooltip = "Remove - removes this news feed.";
	else
		gContentArray[y]["remove"].tooltip = "";

	if (!gContentArray[y]["info"])
	{
		gContentArray[y]["info"] = new Image();
		InitialiseInfo(y);
	}
	gContentArray[y]["info"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['info'], '" + gSkinFolder + "info_up.png')) {AddEditFeed(gFeedArray[" + z + "]);}";
	if (preferences.showHelpTips.value == "1")
		gContentArray[y]["info"].tooltip = "Information - edit the settings for this news feed, including feed URL, display title, number of items and refresh interval.";
	else
		gContentArray[y]["info"].tooltip = "";

	if (growWindow)
	{
		mainWindow.height += gRow_Height;
		gFooter_left.vOffset += gRow_Height;
		gFooter_main.vOffset += gRow_Height;
		gFooter_right.vOffset += gRow_Height;
		gAdd_Button.vOffset += gRow_Height;
		gGrow_Button.vOffset += gRow_Height;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function SetNewsItem(z, x, y)
{
	var		growWindow = false;
	var		rowOffset;

	if (!gContentArray)
		return;

	growWindow = EnsureRowBackground(y);
	
	if (gContentArray[y]["text"])
	{
			// if it's a feed text currently, then reinitialise as a news text
		if (gContentArray[y]["remove"])
			InitialiseTextNews(y);
	}
	else
	{
		gContentArray[y]["text"] = new Text();
		InitialiseTextNews(y);
	}
	gContentArray[y]["text"].data = gFeedArray[z].items[x].title;
	if (gFeedArray[z].items[x].link != "")
		gContentArray[y]["text"].onMouseUp = "openURL('" + gFeedArray[z].items[x].link + "'); if (preferences.autoHideNewsItems.value=='1') {gFeedArray[" + z + "].HideItem(" + x + ");}";			
	gContentArray[y]["text"].tooltip = gFeedArray[z].items[x].title + "\r\r" + gFeedArray[z].items[x].description;

	delete gContentArray[y]["arrow"];
	delete gContentArray[y]["refresh"];
	delete gContentArray[y]["remove"];
	delete gContentArray[y]["info"];

	if (!gContentArray[y]["hide"])
	{
		gContentArray[y]["hide"] = new Image();
		InitialiseHide(y);
	}
	gContentArray[y]["hide"].onMouseUp = "if (RemoveImageTracking(gContentArray[" + y + "]['hide'], '" + gSkinFolder + "hide_up.png')) {gFeedArray[" + z + "].HideItem(" + x + ");}";
	if (preferences.showHelpTips.value == "1")
		gContentArray[y]["hide"].tooltip = "Hide - hides this news item.";
	else
		gContentArray[y]["hide"].tooltip = "";

	if (growWindow)
	{
		mainWindow.height += gRow_Height;
		gFooter_left.vOffset += gRow_Height;
		gFooter_main.vOffset += gRow_Height;
		gFooter_right.vOffset += gRow_Height;
		gAdd_Button.vOffset += gRow_Height;
		gGrow_Button.vOffset += gRow_Height;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
function UpdateGUI()
{
	var		showWindow = false;
	var		y = 0;
	
	suppressUpdates();
	
	for (var z = 0; z < gFeedArray.length; z++)
	{
		var			containerPos = 0;
		var			numContainerItems = 0;
		var			containerToolTip = "";
		var			shownContainer = false;
		
		if (gFeedArray[z].loaded)
		{
			for (var x = 0 ; x < gFeedArray[z].items.length; x++)
			{
				if (gFeedArray[z].items[x].keep == false)
				{
					// delete the item
					
					print("deleting item '" + gFeedArray[z].items[x].title + "'");
					gFeedArray[z].items.splice(x, 1);
					x--;
				}
				else if (gFeedArray[z].items[x] && gFeedArray[z].items[x].hidden)
				{
					// do nothing - want to hide this item
					//print("x = " + x + " - hidden - " + gFeedArray[z].items[x].title);
				}
				else
				{
					if (numContainerItems < gFeedArray[z].maxDisplayItems)
					{
						if (!shownContainer)
						{
							containerPos = y;
							SetContainer(z, containerPos);
							shownContainer = true;
							y++;
						}
					
						showWindow = true;
						
						if (gFeedArray[z].open)
						{
							SetNewsItem(z, x, y);
							y++;
						}
					}

					if (containerToolTip == "")
						containerToolTip = gFeedArray[z].GetDisplayTitle() + "\r\r"
					else
						containerToolTip += "\r";
					containerToolTip += "• " + gFeedArray[z].items[x].title;
					numContainerItems++;
				}
			}
		}
			
		if (!shownContainer && preferences.autoHideFeeds.value != "1")
		{
			containerPos = y;
			SetContainer(z, containerPos);
			shownContainer = true;
			y++;
		}
		
			// only auto-close the news feed if we've shown the container, the feed contains
			// some items, the feed is open, and the auto-close preferences is turned on
		if (shownContainer					&&
			numContainerItems == 0			&&
			gFeedArray[z].items.length > 0	&&
			gFeedArray[z].open				&&
			preferences.autoCloseFeeds.value == "1")
		{
				// use ToggleOpen so that it gets saved
			gFeedArray[z].ToggleOpen(false);
		}
		
		if (shownContainer)
		{
			SetContainerText(z, containerPos, numContainerItems, containerToolTip);
		}
	}
	
	if (y < gContentArray.length)
	{
		for (var x = gContentArray.length - 1; x >= y; x--)
		{
			gContentArray.splice(x, 1);

			mainWindow.height -= gRow_Height;
			gFooter_left.vOffset -= gRow_Height;
			gFooter_main.vOffset -= gRow_Height;
			gFooter_right.vOffset -= gRow_Height;
			gAdd_Button.vOffset -= gRow_Height;
			gGrow_Button.vOffset -= gRow_Height;
		}
	}

	if (gFeedArray.length == 0)
		showWindow = true;

	if (mainWindow.shadow)
		mainWindow.recalcShadow();
	
	resumeUpdates();
	
	if (!showWindow && preferences.autoHideWindow.value != "1")
		showWindow = true;
	
	if (mainWindow.visible != showWindow)
		mainWindow.visible = showWindow;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
